/* ISC license. */

#ifndef SHIBARI_CONSTANTS_H
#define SHIBARI_CONSTANTS_H

enum shibari_qclass_e
{
  SHIBARI_C_IN = 1,
  SHIBARI_C_CH = 3,
  SHIBARI_C_HS = 4,
  SHIBARI_C_NONE = 254,
  SHIBARI_C_ANY = 255,
} ;

enum shibari_qtype_e
{
  SHIBARI_T_A = 1,
  SHIBARI_T_NS = 2,
  SHIBARI_T_MD = 3,
  SHIBARI_T_MF = 4,
  SHIBARI_T_CNAME = 5,
  SHIBARI_T_SOA = 6,
  SHIBARI_T_MB = 7,
  SHIBARI_T_MG = 8,
  SHIBARI_T_MR = 9,
  SHIBARI_T_NULL = 10,
  SHIBARI_T_WKS = 11,
  SHIBARI_T_PTR = 12,
  SHIBARI_T_HINFO = 13,
  SHIBARI_T_MINFO = 14,
  SHIBARI_T_MX = 15,
  SHIBARI_T_TXT = 16,
  SHIBARI_T_RP = 17,
  SHIBARI_T_AFSDB = 18,
  SHIBARI_T_X25 = 19,
  SHIBARI_T_ISDN = 20,
  SHIBARI_T_RT = 21,
  SHIBARI_T_NSAP = 22,
  SHIBARI_T_NSAP_PTR = 23,
  SHIBARI_T_SIG = 24,
  SHIBARI_T_KEY = 25,
  SHIBARI_T_PX = 26,
  SHIBARI_T_GPOS = 27,
  SHIBARI_T_AAAA = 28,
  SHIBARI_T_LOC = 29,
  SHIBARI_T_NXT = 30,
  SHIBARI_T_EID = 31,
  SHIBARI_T_NIMLOC = 32,
  SHIBARI_T_SRV = 33,
  SHIBARI_T_ATMA = 34,
  SHIBARI_T_NAPTR = 35,
  SHIBARI_T_KX = 36,
  SHIBARI_T_CERT = 37,
  SHIBARI_T_A6 = 38,
  SHIBARI_T_DNAME = 39,
  SHIBARI_T_SINK = 40,
  SHIBARI_T_OPT = 41,
  SHIBARI_T_APL = 42,
  SHIBARI_T_DS = 43,
  SHIBARI_T_SSHFP = 44,
  SHIBARI_T_IPSECKEY = 45,
  SHIBARI_T_RRSIG = 46,
  SHIBARI_T_NSEC = 47,
  SHIBARI_T_DNSKEY = 48,
  SHIBARI_T_DHCID = 49,
  SHIBARI_T_NSEC3 = 50,
  SHIBARI_T_NSEC3PARAM = 51,
  SHIBARI_T_TLSA = 52,
  SHIBARI_T_SMIMEA = 53,
  SHIBARI_T_HIP = 55,
  SHIBARI_T_NINFO = 56,
  SHIBARI_T_RKEY = 57,
  SHIBARI_T_TALINK = 58,
  SHIBARI_T_CDS = 59,
  SHIBARI_T_CDNSKEY = 60,
  SHIBARI_T_OPENPGPKEY = 61,
  SHIBARI_T_CSYNC = 62,
  SHIBARI_T_ZONEMD = 63,
  SHIBARI_T_SVCB = 64,
  SHIBARI_T_HTTPS = 65,
  SHIBARI_T_SPF = 99,
  SHIBARI_T_UINFO = 100,
  SHIBARI_T_UID = 101,
  SHIBARI_T_GID = 102,
  SHIBARI_T_UNSPEC = 103,
  SHIBARI_T_NID = 104,
  SHIBARI_T_L32 = 105,
  SHIBARI_T_L64 = 106,
  SHIBARI_T_LP = 107,
  SHIBARI_T_EUI48 = 108,
  SHIBARI_T_EUI64 = 109,
  SHIBARI_T_TKEY = 249,
  SHIBARI_T_TSIG = 250,
  SHIBARI_T_IXFR = 251,
  SHIBARI_T_AXFR = 252,
  SHIBARI_T_MAILB = 253,
  SHIBARI_T_MAILA = 254,
  SHIBARI_T_ANY = 255,
  SHIBARI_T_URI = 256,
  SHIBARI_T_CAA = 257,
  SHIBARI_T_AVC = 258,
  SHIBARI_T_DOA = 259,
  SHIBARI_T_AMIRELAY = 260,
  SHIBARI_T_RESINFO = 261,
  SHIBARI_T_TA = 32768,
  SHIBARI_T_DLV = 32769
} ;

#endif
